/*
half pipe lua, written by -

most functions here are to make usage of this script easier
the only ones that has to be attached are the ones to 
*/
local localver = 1
local localname = "TonyHawk"
local localrev = 0

rawset(_G, "hp_runhalfpipelua", false)

//look for half pipesl ine in a map to know is this library should be used somewhere
local function LocaStoreHalfPipeLines()
	HalfPipe.proceed = mapheaderinfo[gamemap].usehflua ~= nil
	hp_runhalfpipelua = (mapheaderinfo[gamemap].usehflua ~= nil)
end 

-- G: no precision loss on my watch!
local function localAngleToInt(angle, addtn) 
	local a = angle / 11930464 -- 182.044433594
	if a < 0 then a = 360 + a end
	return a + (addtn or 0)
end

//backported from source, gives in which line of al ine isa the point you give
//line can be a real life, or a table pretending to be a line
local function localP_PointOnLineSide(x, y, line)
	local v1 = line.v1

	if not line.dx then
		if x <= v1.x then
			return line.dy > 0
		end

		return line.dy < 0
	end
	if not line.dy then
		if y <= v1.y then
			return line.dx < 0
		end

		return line.dx > 0
	end

	local left = FixedMul(line.dy / FRACUNIT, x - v1.x)
	local right = FixedMul(y - v1.y, line.dx / FRACUNIT)

	return right >= left
end


//gets the closes point in al ine, but clamped to the line edges
//x and y are the coordinates you wanna test this
local function LocalHalfPipeGetCPOL(x, y, line)
	assert(line)
	local px, py = P_ClosestPointOnLine(x, y, line)

	//now we clamp this point to the line range
	local mi = min(line.v1.x, line.v2.x)
	local ma = max(line.v1.x, line.v2.x)
	px = max(mi, min(ma, $))

	mi = min(line.v1.y, line.v2.y)
	ma = max(line.v1.y, line.v2.y)
	py = max(mi, min(ma, $))

	return { x = px, y = py }
end

local function testlines(line, ignore)
	local type = type
	for _, line2 in pairs(ignore) do
		if line2 == line or (type(line2) == "table" and (line2.wall == line or line2.line == line)) then
			return true
		end

		-- recurse
		if type(line2) == "table" then
			if testlines(line, line2) then return true end
		end
	end
end

//gets the closest half pipe line
//type defines how it wanna be searched
//noone or 0 is by distance from the closest point
//1 ir by collision with it 
//radius is necessary if you wanna find lines by collision
//is the distance it should use from the origin to detect collsiion with lines
local function LocalNearestHalfPipeLine(x, y, searchtype, radius, ignore)
	if not radius then radius = 42*FRACUNIT end

	local foundline = {}
	local dummy = P_SpawnMobj(x, y, 0, MT_THOK) -- G: it's called thokpuppets, not gargoylepuppets :Trollic:
	dummy.radius = radius
	searchBlockmap("lines", function(mo, line)
		if line.special == 740 then table.insert(foundline, line) end
	end, dummy)
	P_RemoveMobj(dummy)

	if not searchtype then searchtype = 0 end
	local closest = INT32_MIN
	local collist = {}
	local bestline

	for i, line in ipairs(foundline) do
		if type(ignore) == "userdata" then
			if ignore == line then continue end
		elseif type(ignore) == "table" then //table of lines
			if testlines(line, ignore) then continue end
		end
		local cpol = HalfPipe.funcs.pointonline(x, y, line)
	
		local dist = FixedHypot(x - cpol.x, y - cpol.y)
		
		if searchtype == 0 then
			if dist > closest then
				closest = dist
				bestline = line
			end
		end
		
		if searchtype == 1 then
			/*
				brief explanation
				the game does collision with a box (the 4 eges of the player object in a specific distance)
				what i recoomend is t ogive the radius is  the player radius + its speed + (FRACUNIT*12) 
				to MAKE ABSOLUTELY sure it will happen bedofre the game with aly line
				here instead of 4 sides, we'll have 16
				and if ANY side collides it will be added to a list, and the line that has more collisions, wins
			*/
			
			//wanna use this to check which side is not collision
			//because the player never goes throuhg the line itself
			local defaultside = HalfPipe.funcs.poitonlineside(x, y, line)
			
			local colcount = 0
			
			for j = 1, 16 do
				local xx = x + P_ReturnThrustX(nil, (ANGLE_22h) * j, radius)
				local yy = y + P_ReturnThrustY(nil, (ANGLE_22h) * j, radius)
				local pointcollision = HalfPipe.funcs.poitonlineside(xx, yy, line)
				
				//collided (actually is in a different side of the line than the origin)
				//to avoind "collision" with lines farther away, use the dist 
				if pointcollision ~= defaultside
				and dist <= radius + 4*FRACUNIT then
					colcount = $ + 1
				end
				
			end
			
			//after we count the amount of sides that collided
			//we add this line to the table
			//ONLY IF a collsiion hapenned, ofc
			if colcount ~= 0 then
				table.insert(collist, {line, colcount})
				//sort everytime we found a new one
				
				table.sort(collist, function(a, b) return b[2] > a[2] end)
				bestline = collist[1][1]
			end
		end
	end

	return bestline and {
		wall = bestline,
		angle = R_PointToAngle2(bestline.v1.x, bestline.v1.y, bestline.v2.x, bestline.v2.y),
		front = HalfPipe.funcs.wallfrontangle(bestline, false),
		back = HalfPipe.funcs.wallfrontangle(bestline, true),
	}
end

//get the wall front angle
local function LocalWallFrontAngle(line, back)
	local v1, v2 = line.v1, line.v2
	local lineang = R_PointToAngle2(v1.x, v1.y, v2.x, v2.y)
	local linelenght = FixedHypot(v1.x - v2.x, v1.y - v2.y) / 2

	//go to thel ine mdidle
	local posx = v1.x + P_ReturnThrustX(nil, lineang, linelenght)
	local posy = v1.y + P_ReturnThrustY(nil, lineang, linelenght)
	
	//thrust forwards a bit
	posx = $ + P_ReturnThrustX(nil, lineang + ANGLE_90, 16*FRACUNIT)
	posy = $ + P_ReturnThrustY(nil, lineang + ANGLE_90, 16*FRACUNIT)
	
	//test to know which side it is
	local side = HalfPipe.funcs.poitonlineside(posx, posy, line)	

	local dir = ANGLE_90
	if side ~= (back or false) then
		dir = -ANGLE_90
	end

	return lineang + dir 
end

/*
the folowing was done by Haya, oh boy


*/


-- another edited version of a function that really does not need an onground check :)))))))
local function K_GetKartSpeed(player, doboostpower)
	local g_cc
	local xspd = 3072

	if gamespeed == EASYSPEED then
		g_cc = 53248 + xspd -- 50cc =  81.25 + 4.69 =  85.94%
	elseif gamespeed == HARDSPEED then
		g_cc = 77824 + xspd -- 150cc = 118.75 + 4.69 = 123.44%
	else -- NORMALSPEED
		g_cc = 65536 + xspd -- 100cc = 100.00 + 4.69 = 104.69%
	end

	local kartspeed = player.kartspeed

	if G_BattleGametype() and player.kartstuff[k_bumper] <= 0 then
		kartspeed = 1
	end

	local k_speed = 150 + kartspeed * 3 -- 153 - 177

	local finalspeed = FixedMul(FixedMul(k_speed << 14, g_cc), player.mo.scale)

	if doboostpower then
		return FixedMul(finalspeed, player.kartstuff[k_boostpower] + player.kartstuff[k_speedboost])
	end

	return finalspeed
end

local ORIG_FRICTION = 62914

// having to make our own accelcode is painful, you know
local function fuck(player, forwardmove)
	local playerButtons = player.cmd.buttons
	local accelmax = 4000
	local p_speed = K_GetKartSpeed(player, true)
	local p_accel = K_GetKartAccel(player)
	// ACCELCODE!!!1!11!
	local oldspeed = R_PointToDist2(0, 0, player.rmomx, player.rmomy) // FixedMul(P_AproxDistance(player.rmomx, player.rmomy), player.mo.scale)
	local newspeed = FixedDiv(FixedDiv(FixedMul(oldspeed, accelmax - p_accel) +
		FixedMul(p_speed, p_accel), accelmax), ORIG_FRICTION)

	local finalSpeed = newspeed - oldspeed

	-- forwardmove is:
	--  50 while accelerating,
	--  25 while clutching,
	--   0 with no gas, and
	-- -25 when only braking.

	finalSpeed = $ * (forwardmove/25)
	finalSpeed = $ / 2

	if forwardmove < 0 and finalSpeed > FRACUNIT*2 then
		finalSpeed = finalSpeed/2
	elseif forwardmove < 0 then
		finalSpeed = -FRACUNIT/2
	end

	if finalSpeed < 0 then finalSpeed = 0 end

	return finalSpeed
end

// aa
local function fuck2(player, cmd)
	local movepushforward = FixedMul(fuck(player, cmd.forwardmove), player.mo.movefactor)

	if (cmd.buttons & BT_BRAKE) and cmd.forwardmove == 0 then // SRB2kart - braking isn't instant
		movepushforward = $ / 64
	end

	if cmd.forwardmove > 0 then
		player.kartstuff[k_brakestop] = 0
	elseif player.kartstuff[k_brakestop] < 6 then // Don't start reversing with brakes until you've made a stop first
		if player.speed < 8*FRACUNIT then
			player.kartstuff[k_brakestop] = $ + 1
		end
		return 0
	end

	return movepushforward
end

// countersteer is how strong the controls are telling us we are turning
// turndir is the direction the controls are telling us to turn, -1 if turning right and 1 if turning left
local function KL_GetKartDriftValue(player, countersteer)
	local driftweight = player.kartweight*14 // 12

	// If they aren't drifting or on the ground this doesn't apply
	if player.kartstuff[k_drift] == 0 then
		return 0
	end

	if player.kartstuff[k_driftend] ~= 0 then
		return -266*player.kartstuff[k_drift] // Drift has ended and we are tweaking their angle back a bit
	end

	local basedrift = 83*player.kartstuff[k_drift] - (driftweight - 14)*player.kartstuff[k_drift]/5 // 415 - 303
	local driftangle = abs((252 - driftweight)*player.kartstuff[k_drift]/5)
	
	return basedrift + FixedMul(driftangle, countersteer)
end

freeslot("MT_BRAKEDRIFT_JUG", "sfx_jugadr")
-- mobjinfo[MT_BRAKEDRIFT_JUG] = mobjinfo[MT_BRAKEDRIFT]
mobjinfo[MT_BRAKEDRIFT_JUG] =
{ 	
	doomednum = -1,
	spawnstate = S_BRAKEDRIFT,
	spawnhealth = 1000,
	seestate = S_NULL,
	seesound = sfx_None,
	reactiontime = 8,
	attacksound = sfx_None,
	painstate = S_NULL,
	painchance = 0,
	painsound = sfx_None,
	meleestate = S_NULL,
	missilestate = S_NULL,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_None,
	speed = 8,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	mass = 100, 
	damage = 0,
	activesound = sfx_None,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP, 
	raisestate = S_NULL
}

-- lmao of course this function is not exposed
local function K_SpawnDriftSparks(player, pulse)
	if leveltime % 2 == 1 then return end

	local pks_drift = player.kartstuff[k_drift]
	local pks_charge = player.kartstuff[k_driftcharge]
	if not pks_drift or pks_charge < K_GetKartDriftSparkValue(player) then return end

	local playerMo		= player.mo
	local playerAngle 	= playerMo.angle
	local playerScale	= playerMo.scale
	local playerSpark	= K_GetKartDriftSparkValue(player)
	local cmdDriftTurn	= player.cmd.driftturn

	local travelangle = playerAngle - ((ANGLE_45 / 5) * pks_drift)

	for i = 0,2 do
		local fakeTerniary = 1
		if i & 1 then fakeTerniary = -1 end 

		local newx = playerMo.x + P_ReturnThrustX(playerMo, travelangle + fakeTerniary * ANGLE_135, FixedMul(32 * FRACUNIT, playerScale))
		local newy = playerMo.y + P_ReturnThrustY(playerMo, travelangle + fakeTerniary * ANGLE_135, FixedMul(32 * FRACUNIT, playerScale))
		local sparkMobj = P_SpawnMobj(newx, newy, playerMo.z, MT_DRIFTSPARK)

		sparkMobj.target 	= playerMo
		sparkMobj.angle 	= travelangle - ((ANGLE_45 / 5) * pks_drift)
		sparkMobj.destscale = playerScale
		P_SetScale(sparkMobj, playerScale)

		sparkMobj.momx = playerMo.momx / 2
		sparkMobj.momy = playerMo.momy / 2

		if pks_charge >= playerSpark * 4 then
			sparkMobj.color = 1 + (leveltime % (MAXSKINCOLORS - 1))

		elseif pks_charge >= playerSpark * 2 then
			if pks_charge <= (playerSpark * 2) + (24 * 3) then
				sparkMobj.color = SKINCOLOR_RASPBERRY -- transition
			else
				sparkMobj.color = SKINCOLOR_KETCHUP
			end
		else
			sparkMobj.color = SKINCOLOR_SAPPHIRE
		end

		if (pks_drift > 0 and cmdDriftTurn > 0) or -- Inward drifts
			(pks_drift < 0 and cmdDriftTurn < 0) then

			if (pks_drift < 0 and (i & 1)) or (pks_drift > 0 and not (i & 1)) then
				sparkMobj.state = S_DRIFTSPARK_A1
			elseif (pks_drift < 0 and not (i & 1)) or (pks_drift > 0 and (i & 1)) then
				sparkMobj.state =  S_DRIFTSPARK_C1
			end

		elseif (pks_drift > 0 and cmdDriftTurn < 0) or -- Outward drifts
				(pks_drift < 0 and cmdDriftTurn > 0) then

			if (pks_drift < 0 and (i & 1)) or (pks_drift > 0 and not (i & 1)) then
				sparkMobj.state = S_DRIFTSPARK_C1
			elseif (pks_drift < 0 and not (i & 1)) or (pks_drift > 0 and (i & 1)) then
				sparkMobj.state = S_DRIFTSPARK_A1
			end

		end

		K_MatchGenericExtraFlags(sparkMobj, playerMo)
	end
end

local function K_SpawnBrakeDriftSparks(player)

	local playerMo = player.mo

	-- Position & etc are handled in its thinker, and its spawned invisible.
	-- This avoids needing to dupe code if we don't need it.
	local mobjSparks = P_SpawnMobj(playerMo.x, playerMo.y, playerMo.z, MT_BRAKEDRIFT_JUG)
	mobjSparks.target = playerMo

	mobjSparks.destscale = playerMo.scale
	P_SetScale(mobjSparks, mobjSparks.destscale)
	K_MatchGenericExtraFlags(mobjSparks, playerMo)

	mobjSparks.flags2 = $ | MF2_DONTDRAW
end

local function K_SpawnAIZDust(player)
	if leveltime % 2 == 1 then return end

	local playerMo = player.mo
	local travelangle = R_PointToAngle2(0, 0, playerMo.momx, playerMo.momy)

	local newx = playerMo.x + P_ReturnThrustX(playerMo,
		travelangle - (player.kartstuff[k_aizdriftstrat] * ANGLE_45), FixedMul(24*FRACUNIT, playerMo.scale))
	local newy = playerMo.y + P_ReturnThrustY(playerMo,
		travelangle - (player.kartstuff[k_aizdriftstrat] * ANGLE_45), FixedMul(24*FRACUNIT, playerMo.scale))
	local dustMobj = P_SpawnMobj(newx, newy, playerMo.z, MT_AIZDRIFTSTRAT)

	dustMobj.angle = travelangle + (player.kartstuff[k_aizdriftstrat] * ANGLE_90)
	dustMobj.destscale = (3 * playerMo.scale) >> 2
	P_SetScale(dustMobj, dustMobj.destscale)

	dustMobj.momx = (6 * playerMo.momx) / 5
	dustMobj.momy = (6 * playerMo.momy) / 5
	dustMobj.momz = playerMo.momz / 2

	K_MatchGenericExtraFlags(dustMobj, playerMo)
	-- print("hello")
end

// i hate porting code i hate porting code i hate
local function K_KartDrift(player)
	local minspeed = 10 * player.mo.scale
	local dsone = K_GetKartDriftSparkValue(player)
	local dstwo = dsone * 2
	local dsthree = dstwo * 2

	-- Grown players taking yellow spring panels will go below minspeed for one tic,
	-- and will then wrongdrift or have their sparks removed because of this.
	-- This fixes this problem.
	if player.kartstuff[k_pogospring] == 2 and player.mo.scale > mapobjectscale then
		minspeed = FixedMul(10 << FRACBITS, mapobjectscale)
	end

	-- Drifting is actually strafing + automatic turning.
	-- Holding the Jump button will enable drifting.

	-- Drift Release (Moved here so you can't "chain" drifts)
	if (player.kartstuff[k_drift] ~= -5 and player.kartstuff[k_drift] ~= 5)
			and player.kartstuff[k_driftcharge] < dsone then
		player.kartstuff[k_driftcharge] = 0
	elseif (player.kartstuff[k_drift] ~= -5 and player.kartstuff[k_drift] ~= 5)
			and (player.kartstuff[k_driftcharge] >= dsone and player.kartstuff[k_driftcharge] < dstwo) then
		if player.kartstuff[k_driftboost] < 20 then
			player.kartstuff[k_driftboost] = 20
		end
		S_StartSound(player.mo, sfx_s23c)
		-- K_SpawnDashDustRelease(player)
		player.kartstuff[k_driftcharge] = 0
	elseif (player.kartstuff[k_drift] ~= -5 and player.kartstuff[k_drift] ~= 5)
			and player.kartstuff[k_driftcharge] < dsthree then
		if player.kartstuff[k_driftboost] < 50 then
			player.kartstuff[k_driftboost] = 50
		end
		S_StartSound(player.mo, sfx_s23c)
		-- K_SpawnDashDustRelease(player)
		player.kartstuff[k_driftcharge] = 0
	elseif (player.kartstuff[k_drift] ~= -5 and player.kartstuff[k_drift] ~= 5)
			and player.kartstuff[k_driftcharge] >= dsthree then
		if player.kartstuff[k_driftboost] < 125 then
			player.kartstuff[k_driftboost] = 125
		end
		S_StartSound(player.mo, sfx_s23c)
		-- K_SpawnDashDustRelease(player)
		player.kartstuff[k_driftcharge] = 0
	end
	
	-- Drifting: left or right?
	if player.cmd.driftturn > 0 and player.wallspeed > minspeed and player.kartstuff[k_jmp] == 1
			and (player.kartstuff[k_drift] == 0 or player.kartstuff[k_driftend] == 1) then
		-- Starting left drift
		player.kartstuff[k_drift] = 1
		player.kartstuff[k_driftend] = 0
	elseif player.cmd.driftturn < 0 and player.wallspeed > minspeed and player.kartstuff[k_jmp] == 1
			and (player.kartstuff[k_drift] == 0 or player.kartstuff[k_driftend] == 1) then
		-- Starting right drift
		player.kartstuff[k_drift] = -1
		player.kartstuff[k_driftend] = 0
	elseif player.kartstuff[k_jmp] == 0 then
		-- drift is not being performed so if we're just finishing set driftend and decrement counters
		if player.kartstuff[k_drift] > 0 then
			player.kartstuff[k_drift] = player.kartstuff[k_drift] - 1
			player.kartstuff[k_driftend] = 1
		elseif player.kartstuff[k_drift] < 0 then
			player.kartstuff[k_drift] = player.kartstuff[k_drift] + 1
			player.kartstuff[k_driftend] = 1
		else
			player.kartstuff[k_driftend] = 0
		end
	end

	-- Increase/decrease the drift value to continue drifting in that direction
	if player.kartstuff[k_spinouttimer] == 0 and player.kartstuff[k_jmp] == 1 and player.kartstuff[k_drift] ~= 0 then
		local driftadditive = 24

		if player.kartstuff[k_drift] >= 1 then -- Drifting to the left
			player.kartstuff[k_drift] = player.kartstuff[k_drift] + 1
			if player.kartstuff[k_drift] > 5 then
				player.kartstuff[k_drift] = 5
			end

			if player.cmd.driftturn > 0 then -- Inward
				driftadditive = driftadditive + abs(player.cmd.driftturn) / 100
			end
			if player.cmd.driftturn < 0 then -- Outward
				driftadditive = driftadditive - abs(player.cmd.driftturn) / 75
			end
		elseif player.kartstuff[k_drift] <= -1 then -- Drifting to the right
			player.kartstuff[k_drift] = player.kartstuff[k_drift] - 1
			if player.kartstuff[k_drift] < -5 then
				player.kartstuff[k_drift] = -5
			end

			if player.cmd.driftturn < 0 then -- Inward
				driftadditive = driftadditive + abs(player.cmd.driftturn) / 100
			end
			if player.cmd.driftturn > 0 then -- Outward
				driftadditive = driftadditive - abs(player.cmd.driftturn) / 75
			end
		end

		-- Disable drift-sparks until you're going fast enough
		if player.kartstuff[k_getsparks] == 0 or (player.kartstuff[k_offroad] and not player.kartstuff[k_invincibilitytimer] and not player.kartstuff[k_hyudorotimer] and not player.kartstuff[k_sneakertimer]) then
			driftadditive = 0
		end
		if player.wallspeed > minspeed * 2 then
			player.kartstuff[k_getsparks] = 1
		end

		-- This spawns the drift sparks
		if player.kartstuff[k_driftcharge] + driftadditive >= dsone then
			K_SpawnDriftSparks(player)
		end

		-- Sound whenever you get a different tier of sparks
		if consoleplayer == player and ((player.kartstuff[k_driftcharge] < dsone and player.kartstuff[k_driftcharge] + driftadditive >= dsone)
				or (player.kartstuff[k_driftcharge] < dstwo and player.kartstuff[k_driftcharge] + driftadditive >= dstwo)
				or (player.kartstuff[k_driftcharge] < dsthree and player.kartstuff[k_driftcharge] + driftadditive >= dsthree)) then
			-- S_StartSound(player.mo, sfx_s3ka2)
			S_StartSoundAtVolume(player.mo, sfx_s3ka2, 192) -- Ugh...
		end

		player.kartstuff[k_driftcharge] = player.kartstuff[k_driftcharge] + driftadditive
		player.kartstuff[k_driftend] = 0
	end

	-- Stop drifting
	if player.kartstuff[k_spinouttimer] > 0 or player.wallspeed < minspeed then
		player.kartstuff[k_driftcharge] = 0
		player.kartstuff[k_drift] = 0
		player.kartstuff[k_aizdriftstrat] = 0
		player.kartstuff[k_aizdriftstrat] = 0
		player.kartstuff[k_getsparks] = 0
	end

	if (not player.kartstuff[k_sneakertimer])
			or (not player.cmd.driftturn)
			or (not player.kartstuff[k_aizdriftstrat])
			or (player.cmd.driftturn > 0) ~= (player.kartstuff[k_aizdriftstrat] > 0) then
		if not player.kartstuff[k_drift] then
			player.kartstuff[k_aizdriftstrat] = 0
		else
			player.kartstuff[k_aizdriftstrat] = (player.kartstuff[k_drift] > 0) and 1 or -1
		end
	else
		if player.kartstuff[k_aizdriftstrat] and not player.kartstuff[k_drift] then
			K_SpawnAIZDust(player)
		end
	end

	if player.kartstuff[k_drift] and ((player.cmd.buttons & BT_BRAKE)
			or not (player.cmd.buttons & BT_ACCELERATE)) then
		if not player.kartstuff[k_brakedrift] then
			K_SpawnBrakeDriftSparks(player)
		end
		player.kartstuff[k_brakedrift] = 1
	else
		player.kartstuff[k_brakedrift] = 0
	end
	
	//print("drift: "..player.kartstuff[k_drift].." charge: "..player.kartstuff[k_driftcharge])
	//print("boost: "..player.kartstuff[k_driftboost])
end

// Turn value lua implementation
rawset(_G, "KL_GetKartTurnValue", function(player, turnvalue)
	local p_maxspeed = FixedMul(K_GetKartSpeed(player, false), 3*FRACUNIT)
	local adjustangle = FixedDiv((p_maxspeed>>16) - (player.speed>>16), (p_maxspeed>>16) + player.kartweight)

	if (player.spectator) then return turnvalue end

	if (player.kartstuff[k_drift] ~= 0)
		// If we're drifting we have a completely different turning value
		
		if (player.kartstuff[k_driftend] == 0)
			// 800 is the max set in g_game.c with angleturn
			local countersteer = turnvalue/800
			turnvalue = (KL_GetKartDriftValue(player, countersteer))
		else
			turnvalue = (turnvalue + KL_GetKartDriftValue(player, FRACUNIT))
		end

		return turnvalue
	end

	turnvalue = FixedMul(turnvalue, adjustangle) // Weight has a small effect on turning

	if (player.kartstuff[k_invincibilitytimer] or player.kartstuff[k_sneakertimer] or player.kartstuff[k_growshrinktimer] > 0)
		turnvalue = FixedMul(turnvalue, FixedDiv(5*FRACUNIT, 4*FRACUNIT))
	end

	return turnvalue
end)

// courtesy of juggy, hi juggy
local ITEMTIME		= 8 * TICRATE
local function K_CreateRocketSneakers(playerMo)
	K_PlayBoostTaunt(playerMo)
	S_StartSound(playerMo, sfx_s3k3a)

	local player = playerMo.player

	player.kartstuff[k_rocketsneakertimer] = ITEMTIME * 3
	player.kartstuff[k_itemamount] = $ - 1
	
	-- We have to create the rocket sneakers ourselves.
	local prev = playerMo
	for i = 0,1 do
		local rocketSneakerMo = P_SpawnMobj(playerMo.x, playerMo.y, playerMo.z, MT_ROCKETSNEAKER)
		K_MatchGenericExtraFlags(rocketSneakerMo, playerMo)
		rocketSneakerMo.flags		= $ + MF_NOCLIPTHING
		rocketSneakerMo.angle 		= playerMo.angle
		rocketSneakerMo.threshold 	= 10 
		rocketSneakerMo.movecount 	= i % 2
		rocketSneakerMo.movedir		= i + 1
		rocketSneakerMo.lastlook 	= i + 1
		rocketSneakerMo.target 		= playerMo
		rocketSneakerMo.hprev 		= prev
		prev.hnext 					= rocketSneakerMo

		prev 						= rocketSneakerMo
	end
end

local function itemcode(player, playerMo)
	local playerButtons = player.cmd.buttons
	local pks = player.kartstuff

	-- Press item while holding a sneaker to enable the sneaker in mid-air
	-- Holding the button will not use multiple sneakers.
	player.holdingItemBTN = $ or false
	if (playerButtons & BT_ATTACK) == BT_ATTACK and
		player.holdingItemBTN == false then
		
		-- Because you normally cannot use speed items in the air, the
		-- whole behaviour has to be recreated from hardcode to Lua.

		-- Rocket Sneaker behaviour when already deployed.
		if pks[k_rocketsneakertimer] > 1 then
			K_DoSneaker(player, 2) -- taunt
			K_PlayBoostTaunt(playerMo)
			pks[k_rocketsneakertimer] = $ - (2 * TICRATE)
			
			if pks[k_rocketsneakertimer] < 1 then
				pks[k_rocketsneakertimer] = 1
			end
		--Rocket Sneaker behaviour when not deployed.
		elseif pks[k_itemtype] == KITEM_ROCKETSNEAKER then
			K_CreateRocketSneakers(playerMo)
		-- Sneaker behaviour
		elseif pks[k_itemtype] == KITEM_SNEAKER then
			K_DoSneaker(player, 1) -- taunt
			K_PlayBoostTaunt(playerMo)
			pks[k_itemamount] = $ - 1
		end

		-- Make item button holding persist between deaths.
		if player.holdingItemBTN == false then
			player.holdingItemBTN = true
		end
	elseif (playerButtons & BT_ATTACK) ~= BT_ATTACK and
		player.holdingItemBTN == true then -- Let go.
		player.holdingItemBTN = false
	end
end

if not (HalfPipe and HalfPipe.valid) then
	rawset(_G,"HalfPipe",{
	proceed = false, //to know if a map hash alf pie lines
	funcs = {}, //functions goes here
	ver = localver, //identify from other versions to keep it clean
	revision = localrev, //yaay hotfixes exists
	vername = localname //funny
	}) //hello

	HalfPipe.funcs.loadhalfpipelines = LocaStoreHalfPipeLines
	HalfPipe.funcs.poitonlineside = localP_PointOnLineSide
	HalfPipe.funcs.pointonline = LocalHalfPipeGetCPOL
	HalfPipe.funcs.gethalfpipeline = LocalNearestHalfPipeLine
	HalfPipe.funcs.angletoint = localAngleToInt
	HalfPipe.funcs.wallfrontangle = LocalWallFrontAngle
	HalfPipe.funcs.accelCode = fuck
	HalfPipe.funcs.ThreedKartMovement = fuck2
	HalfPipe.funcs.getTurnValue = KL_GetKartTurnValue
	HalfPipe.funcs.kansaiDurifto = K_KartDrift
	HalfPipe.funcs.handleItems = itemcode
	
	addHook("MapLoad",HalfPipe.funcs.loadhalfpipelines)
	addHook("NetVars",HalfPipe.funcs.loadhalfpipelines)
end
if (HalfPipe and HalfPipe.valid and HalfPipe.ver < localver ) or (HalfPipe and HalfPipe.valid and HalfPipe.ver == localver and HalfPipe.revision < localrev) then
	HalfPipe.funcs = {}
	HalfPipe.ver = localver
	HalfPipe.revision = localrev
	HalfPipe.vername = localname
	HalfPipe.funcs.loadhalfpipelines = LocaStoreHalfPipeLines
	HalfPipe.funcs.poitonlineside = localP_PointOnLineSide
	HalfPipe.funcs.pointonline = LocalHalfPipeGetCPOL
	HalfPipe.funcs.gethalfpipeline = LocalNearestHalfPipeLine
	HalfPipe.funcs.angletoint = localAngleToInt
	HalfPipe.funcs.wallfrontangle = LocalWallFrontAngle
	HalfPipe.funcs.accelCode = fuck
	HalfPipe.funcs.ThreedKartMovement = fuck2
	HalfPipe.funcs.getTurnValue = KL_GetKartTurnValue
	HalfPipe.funcs.kansaiDurifto = K_KartDrift
	HalfPipe.funcs.handleItems = itemcode

end
