// BETTERTELEPORT: A direct replacement for Linedef type 412. With combi support!
// Does not override existing teleporters. Trust me. I've tried.

if teleportscript_loaded then return end // bruh

local function P_FindSectorFromLineTag(line)
	if line.tag == -1 then return -1 end -- don't even bother searching.
	for sector in sectors.iterate do
		if sector.tag == line.tag then
			return #sector
		end
	end
end
local function P_GetObjectTypeInSectorNum(thingtype, sector)
	for mobj in sectors[sector].thinglist() do
		if mobj.type == thingtype then
			return mobj
		end
	end
	return nil
end
-- replication :trollic:
local function P_Teleport(mobj, x, y, z, angle, flash, dontstopmove)
	P_SetOrigin(mobj, x, y, z)
	
	mobj.angle = angle
	
	if not dontstopmove then
		mobj.momx, mobj.momy, mobj.momz = 0, 0, 0
	else
		P_InstaThrust(mobj, mobj.angle, P_AproxDistance(mobj.momx, mobj.momy))
	end
	
	if mobj.player then
		if mobj.eflags & MFE_VERTICALFLIP then
			mobj.player.viewz = mobj.z + mobj.height - mobj.player.viewheight
		else
			mobj.player.viewz = mobj.z + mobj.player.viewheight
		end
		
		COM_BufInsertText(mobj.player, "resetcamera")
		
		if not dontstopmove then
			mobj.reactiontime = TICRATE/2
			
			for p in players.iterate do
				if p.spectator then continue end
				if not (p.mo and p.mo.valid) then continue end
				
				-- ??????????
				if p.pflags & PF_CARRIED and p.mo.tracer == mobj then
					p.pflags = $ & ~PF_CARRIED
				end
			end
			
			mobj.player.cmomx, mobj.player.cmomy = 0, 0
			mobj.player.rmomx, mobj.player.rmomy = 0, 0
			
			mobj.player.speed = 0
			
			P_ResetPlayer(mobj.player)
			
			mobj.state = S_KART_STND1
		end
		
		if flash then
			P_FlashPal(mobj.player, PAL_MIXUP, 10)
		end
	end
end

addHook("LinedefExecute", function(line, mobj, sector)
	if line.flags & ML_EFFECT3 then
		local x = sides[line.sidenum[0]].textureoffset
		local y = sides[line.sidenum[0]].rowoffset
		local z = line.frontsector.ceilingheight
		
		P_SetOrigin(mobj, mobj.x+x, mobj.y+y, mobj.z+z)
		COM_BufInsertText(mobj.player, "resetcamera")
		if mobj.player and mobj.player.valid then
			if hcombi and hcombi.combi_on then
				P_SetOrigin(mobj.player.combi_p.mo, mobj.player.combi_p.mo.x+x, mobj.player.combi_p.mo.y+y, mobj.player.combi_p.mo.z+z)
				if mobj.player.combi_p.valid then
					COM_BufInsertText(mobj.player.combi_p, "resetcamera")
				end
			end
			
			-- HYUU!!!!!!!!!!!!!
			if mobj.player and mobj.player.valid and mobj.player.kartstuff[k_hyudorotimer] < 35 then
				mobj.player.kartstuff[k_hyudorotimer] = 35
			end
			
			if hcombi and hcombi.combi_on and mobj.player.has_partner then
				if mobj.player.combi_p.kartstuff[k_hyudorotimer] < 35 then
					mobj.player.combi_p.kartstuff[k_hyudorotimer] = 35
				end
			end
			
			if mobj.player.golfobj and mobj.player.golfobj.valid then
				S_StartSound(mobj, sfx_mixup) -- bwoosh
				P_FlashPal(mobj.player, PAL_MIXUP, 10)
				P_SetOrigin(mobj.player.golfobj, mobj.player.golfobj.x+x, mobj.player.golfobj.y+y, mobj.player.golfobj.z+z)
			end
		end
	else
		local secnum = P_FindSectorFromLineTag(line)
		if secnum < 0 then return end -- nothing.
		
		local dest = P_GetObjectTypeInSectorNum(MT_TELEPORTMAN, secnum)
		if dest == nil then return end -- nothing.
		
		local angleshit = dest.angle
		if line.flags & ML_NOCLIMB then 
			angleshit = mobj.angle
		end
		local effect4 = false
		if line.flags & ML_EFFECT4 then 
			effect4 = true
		end
		
		-- HYUU!!!!!!!!!!!!!
		if mobj.player and mobj.player.valid and mobj.player.kartstuff[k_hyudorotimer] < 35 then
			mobj.player.kartstuff[k_hyudorotimer] = 35
		end
		
		if hcombi and hcombi.combi_on and mobj.player.has_partner then
			if mobj.player.combi_p.kartstuff[k_hyudorotimer] < 35 then
				mobj.player.combi_p.kartstuff[k_hyudorotimer] = 35
			end
		end
		
		if line.flags & ML_BLOCKMONSTERS then
			P_Teleport(mobj, dest.x, dest.y, dest.z, angleshit, false, effect4)
			if hcombi and hcombi.combi_on then
				P_Teleport(mobj.player.combi_p.mo, dest.x, dest.y, dest.z, angleshit, false, effect4)
			end
		else
			P_Teleport(mobj, dest.x, dest.y, dest.z, angleshit, true, effect4)
			S_StartSound(mobj, sfx_mixup) -- bwoosh
			if hcombi and hcombi.combi_on then
				P_Teleport(mobj.player.combi_p.mo, dest.x, dest.y, dest.z, angleshit, true, effect4)
				S_StartSound(mobj.player.combi_p.mo, sfx_mixup) -- bwoosh
			end
		end
		
		if mobj.player and mobj.player.valid and mobj.player.golfobj and mobj.player.golfobj.valid then
			mobj.player.fakeangle = angleshit
			mobj.player.golfobj.prevmomz = 0
			mobj.player.gf.stilltime = 0
			mobj.player.gf.hittingflat = false
			P_Teleport(mobj.player.golfobj, dest.x, dest.y, dest.z, angleshit, false, effect4)
		end
	end
end, "LUATELPT")

rawset(_G, "teleportscript_loaded", 1)