// RACESTART: Custom map-specific race start music!

if racestart_loaded then return end -- boo

-- taken from LUA_OBSK.lua
local function tableparse(x)
	local y = {}
	local i = 0
	for word in x:gmatch('[^,%s]+') do
		y[i+1] = word 
		i = $+1
	end	
	return y
end

local curmustable = {}

addHook("MapChange", function(mapnum)
	-- reset the music table everytime
	curmustable = {}
	if mapheaderinfo[mapnum].rsmusic ~= nil then
		curmustable = tableparse(mapheaderinfo[mapnum].rsmusic)
	end
end)

addHook("MusicChange", function(oldmusic, newmusic, flags, looping)
	if curmustable == {} then return end
	local muslump = curmustable[1]
	if encoremode then muslump = curmustable[2] end
	if oldmusic == muslump and newmusic ~= muslump then
		return muslump
	end
	
	if newmusic == "kstart"
	or newmusic == "estart" then
		return muslump -- You're GONNA hear this fucking starting music.
	end
end)

rawset(_G, "racestart_loaded", 1)