// yeah

local stairstepsound = nil
local dostairsteps = false
local MFE_JUSTSTEPPEDDOWN = MFE_JUSTSTEPPEDDOWN

addHook("MapLoad", function()
	dostairsteps = (mapheaderinfo[gamemap].stairstepsound ~= nil)
	stairstepsound = mapheaderinfo[gamemap].stairstepsound
end)

addHook("NetVars", function(net)
	dostairsteps = net($)
	stairstepsound = net($)
end)

addHook("MobjThinker", function(mo)
	if mo.player == nil then return end
	
	mo.ststep_lastz = mo.z
end, MT_PLAYER)

addHook("PlayerThink", function(p)
	if not dostairsteps then return end
	if p.spectator or not (p.mo and p.mo.valid) then return end
	
	local mo = p.mo
	
	if not P_IsObjectOnGround(mo) then return end // not on the ground
	if not (mo.eflags & MFE_JUSTSTEPPEDDOWN) then return end // not "stepped down" yet
	if mo.ststep_lastz == mo.z then return end // same z coordinate
	
	local sec = P_ThingOnSpecial3DFloor(mo)
	if not sec then sec = mo.subsector.sector end
	
	if sec.special ~= GetSecSpecial(13, 1) then return end // undesired sector special
	
	local slope = "f_slope"
	if P_MobjFlip(mo) < 0 then slope = "c_slope" end
	
	if sec[slope] ~= nil then return end // has a slope

	S_StartSound(mo, _G[stairstepsound])
end)